local isme, istarget, isfocus = _G.COMBATLOG_OBJECT_AFFILIATION_MINE, _G.COMBATLOG_OBJECT_TARGET, _G.COMBATLOG_OBJECT_FOCUS;
local rtmask, rt1 = _G.COMBATLOG_OBJECT_SPECIAL_MASK, _G.COMBATLOG_OBJECT_RAIDTARGET1;
local ricon = {
	"Interface\\TargetingFrame\\UI-RaidTargetingIcon_1",
	"Interface\\TargetingFrame\\UI-RaidTargetingIcon_2",
	"Interface\\TargetingFrame\\UI-RaidTargetingIcon_3",
	"Interface\\TargetingFrame\\UI-RaidTargetingIcon_4",
	"Interface\\TargetingFrame\\UI-RaidTargetingIcon_5",
	"Interface\\TargetingFrame\\UI-RaidTargetingIcon_6",
	"Interface\\TargetingFrame\\UI-RaidTargetingIcon_7",
	"Interface\\TargetingFrame\\UI-RaidTargetingIcon_8"
};
local active = {};

local bband, GetTime, UnitDebuff, CreateFrame, UnitGUID, GetPrimaryTalentTree = bit.band, GetTime, UnitDebuff, CreateFrame, UnitGUID, GetPrimaryTalentTree;
local pairs, ipairs, tremove, tinsert = pairs, ipairs, tremove, tinsert;

local lb = CreateFrame("Frame", "LivingBomber", UIParent);
lb:SetWidth(200);
lb:SetHeight(20);
lb:SetPoint("CENTER", 119, -50);
lb.bars = {};
lb:RegisterEvent("ADDON_LOADED");

local BWIDTH, BSIZE, BSCALE, BDIRECTION = 166, 16, 1, "DOWN";
local LB_ID, IMP_ID = 44457, 64343;
local SPELL_DURATION, lbicon, lbname = 12, nil, nil;
local lb_stamp, imp_stamp = 0, 0;

local function t_removebyval(t, val)
	for k, v in pairs(t) do
		if(v == val) then
			tremove(t, k);
			return true;
		end;
	end;

	return false;
end;

local function t_exists(t, val)
	for k, v in pairs(t) do
		if(v == val) then
			return true;
		end;
	end;

	return false;
end;

local function raid_icon(flag)
	local number, mask, mark;

	if(bband(flag, rtmask) ~= 0) then
		for i = 1, 8 do
			mask = rt1 * (2 ^ (i - 1));
			mark = (bband(flag, mask) == mask);
			if(mark) then number = i; break; end;
		end
	end

	return number and ricon[number] or nil;
end;

local function updatepositions(f)
	local bar, active = nil, active;
	local last = #active;
	local BDIRECTION = BDIRECTION;

	for i, v in ipairs(active) do
		bar = f.bars[v];

		if(i == last) then
			if(BDIRECTION == "DOWN") then
				bar:SetPoint("TOP", f);
			elseif(BDIRECTION == "UP") then
				bar:SetPoint("BOTTOM", f);
			end;
		else
			if(BDIRECTION == "DOWN") then
				bar:SetPoint("TOP", f.bars[active[i + 1]], "BOTTOM", 0, 0);
			elseif(BDIRECTION == "UP") then
				bar:SetPoint("BOTTOM", f.bars[active[i + 1]], "TOP", 0, 0);
			end;
		end;

	end;
end;

local function OnUpdate(self, elapsed)
  self.TimeSinceLastUpdate = self.TimeSinceLastUpdate + elapsed;

  if(self.TimeSinceLastUpdate > 0.2) then
		local time = self.expirationTime - GetTime();

		if(time < 0) then
			self:Hide();
			self:SetScript("OnUpdate", nil);
			self:SetParent(nil);
			lb.bars[self.destGUID] = nil;
			t_removebyval(active, self.destGUID);
		else
			self.statusbar:SetValue(time);
			self.time:SetFormattedText("%d s", time);
		end;

    self.TimeSinceLastUpdate = 0;
  end;
end;

local function lb_addbar(lbframe, timestamp, destGUID, istarget, isfocus, destName, icon)
	local _, tduration, texpiration, tcurrent = nil, 0, 0, GetTime();

	--impact spreading, impact faded in the last second and we didn't cast LB in that second
	if(imp_stamp > 0 and (tcurrent - imp_stamp) < 1 and (tcurrent - lb_stamp) > 1) then
		_, _, _, _, _, tduration, texpiration = UnitDebuff("TARGET", lbname, nil, "PLAYER");
	else
		lb_stamp = 0;
		local unit = (isfocus and "FOCUS" or "TARGET");--this includes the case of mouseovers where we try and cheat
		_, _, _, _, _, tduration, texpiration = UnitDebuff(unit, lbname, nil, "PLAYER");

		if(not isfocus and not istarget and tduration) then
			texpiration = GetTime() + tduration;
		end;
	end;

	--since blizzard sucks and UnitAura is not updated in time
	if(tduration and tduration > 0) then
		SPELL_DURATION = tduration;
	else
		tduration = SPELL_DURATION;
		texpiration = tcurrent + tduration;
	end;

	--SPELL_AURA_REFRESH
	if(lbframe.bars[destGUID]) then
		local bar = lbframe.bars[destGUID];
		bar.expirationTime = texpiration;
		local time = bar.expirationTime - tcurrent;
		bar.statusbar:SetMinMaxValues(0, tduration);
		bar.statusbar:SetValue(time);
		bar.time:SetFormattedText("%d s", time);
		updatepositions(lbframe);
		return;
	end;

	local bar = CreateFrame("Frame", nil, lbframe);
	tinsert(active, destGUID);

	bar.destGUID = destGUID;
	bar.expirationTime = texpiration;
	bar:SetWidth(BSIZE);
	bar:SetHeight(BSIZE);
	bar:SetScale(BSCALE);

	bar.icon = bar:CreateTexture(nil, "BACKGROUND");
	bar.icon:SetAllPoints();
	bar.icon:SetTexCoord(0.07, 0.93, 0.07, 0.93);
	bar.statusbar = CreateFrame("StatusBar", nil, bar);
	bar.statusbar:SetWidth(BWIDTH);
	bar.statusbar:SetHeight(BSIZE);
	bar.statusbar:SetStatusBarTexture("Interface\\AddOns\\LivingBomber\\Textures\\statusbar");
	bar.statusbar:SetStatusBarColor(0.3, 0.64, 0.82, 1);
	bar.statusbar:SetPoint("LEFT", bar, "RIGHT");
	bar.statusbar:SetMinMaxValues(0, 1);
	bar.statusbar:SetValue(0);
	bar.statusbar.background = bar.statusbar:CreateTexture(nil, "BACKGROUND");
	bar.statusbar.background:SetAllPoints();
	bar.statusbar.background:SetTexture("Interface\\AddOns\\LivingBomber\\Textures\\statusbar");
	bar.statusbar.background:SetVertexColor(0.4, 0.4, 0.4, 0.3);

	--local guid = UnitGUID("target");
	--if(guid ~= destGUID) then
	if(not istarget) then
		bar.statusbar:SetAlpha(0.7);
	end;

	bar.time = bar.statusbar:CreateFontString(nil, "ARTWORK", "GameFontHighlightRight");
	bar.time:SetPoint("RIGHT", bar.statusbar, -2, 1);
	bar.spellname = bar.statusbar:CreateFontString(nil, "ARTWORK", "GameFontHighlightSmall");
	bar.spellname:SetPoint("LEFT", bar.statusbar, 2, 1);
	bar.spellname:SetPoint("RIGHT", bar.time, "LEFT");
	bar.spellname:SetJustifyH("CENTER");

	bar.icon:SetTexture(icon or lbicon);
	bar.spellName = destName;
	bar.spellname:SetText(destName);
	bar.statusbar:SetMinMaxValues(0, tduration);

	local time = bar.expirationTime - tcurrent;
	bar.statusbar:SetValue(time);
	bar.time:SetFormattedText("%d s", time);
	lbframe.bars[destGUID] = bar;
	updatepositions(lbframe);
	bar:Show();
	bar.TimeSinceLastUpdate = 0;
	bar:SetScript("OnUpdate", OnUpdate);
end;

local function lb_quashbar(lbframe, destGUID)
	local bar = nil;

	if(active and t_exists(active, destGUID)) then
		bar = lbframe.bars[destGUID];
		if(not bar) then return; end;

		bar:Hide();
		bar:SetScript("OnUpdate", nil);
		bar:SetParent(nil);
		bar = nil;
		lbframe.bars[destGUID] = nil;
		t_removebyval(active, destGUID);
	end;
end;

lb:SetScript("OnEvent", function(self, event, ...)
	self[event](self, ...)
end);

function lb:PLAYER_TARGET_CHANGED()
	local bar, active, last = nil, active, #active;
	if(last == 0) then return; end;

	local g, guid = nil, UnitGUID("target");

	for i = 1, last, 1 do
		g = active[i];
		bar = self.bars[g];

		if(g ~= guid and bar.statusbar:GetAlpha() == 1) then bar.statusbar:SetAlpha(0.7); end;
		if(g == guid and bar.statusbar:GetAlpha() ~= 1) then bar.statusbar:SetAlpha(1); end;
	end;
end;

function lb:COMBAT_LOG_EVENT_UNFILTERED(timestamp, event, hideCaster, srcGUID, srcName, srcFlags, sourceRaidFlags, destGUID, destName, destFlags, destRaidFlags, spellId, spellName)
	if(bband(isme, srcFlags) == 0) then return; end;
	if(spellId ~= LB_ID and spellId ~= IMP_ID) then return; end;

	if(spellId == LB_ID and (event == "SPELL_AURA_APPLIED" or event == "SPELL_AURA_REFRESH")) then
		lb_addbar(self, GetTime(), destGUID, (bband(istarget, destFlags) == istarget), (bband(isfocus, destFlags) == isfocus), destName, raid_icon(destRaidFlags));
	elseif(spellId == LB_ID and event == "SPELL_AURA_REMOVED") then
		lb_quashbar(self, destGUID);

		--re-sort only when the fading bar isn't the last one on the list
		if(destGUID ~= active[#active]) then
			updatepositions(self);
		end;
	elseif(spellId == IMP_ID and event == "SPELL_AURA_REMOVED") then
		imp_stamp = GetTime();
	elseif(spellId == LB_ID and event == "SPELL_CAST_SUCCESS") then
		lb_stamp = GetTime();
	end;
end;

function lb:PLAYER_REGEN_ENABLED()
	lb:UnregisterEvent("COMBAT_LOG_EVENT_UNFILTERED");
end;

function lb:PLAYER_REGEN_DISABLED()
	if(GetPrimaryTalentTree() == 2) then
		lb:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED");
	end;
end;

function lb:ADDON_LOADED(v)
	if(v ~= "LivingBomber" or select(2, UnitClass("player")) ~= "MAGE") then return end;
	local _;

	lbname, _, lbicon = GetSpellInfo(LB_ID);

	lb:RegisterEvent("PLAYER_REGEN_ENABLED");
	lb:RegisterEvent("PLAYER_REGEN_DISABLED");
	lb:RegisterEvent("PLAYER_TARGET_CHANGED");
end;